package cn.edu.nudt.mice.italk;

import org.eclipse.ui.plugin.*;
import org.eclipse.core.runtime.*;
import org.eclipse.core.resources.*;
import org.eclipse.jface.preference.IPreferenceStore;

import cn.edu.nudt.mice.italk.preferences.TalkPreferencePage;
import cn.nudt.edu.mice.italk.peer.TalkServer;

import java.util.*;

/**
 * The main plugin class to be used in the desktop.
 */
public class TalkPlugin extends AbstractUIPlugin {
	//The shared instance.
	private static TalkPlugin plugin;
	//Resource bundle.
	private ResourceBundle resourceBundle;

	/**
	 * The constructor.
	 */
	public TalkPlugin(IPluginDescriptor descriptor) {
		super(descriptor);
		plugin = this;
		try {
			resourceBundle= ResourceBundle.getBundle("cn.edu.nudt.mice.eclipse.italk.TalkPluginResources");
		} catch (MissingResourceException x) {
			resourceBundle = null;
		}
	}

	/**
	 * Returns the shared instance.
	 */
	public static TalkPlugin getDefault() {
		return plugin;
	}

	/**
	 * Returns the workspace instance.
	 */
	public static IWorkspace getWorkspace() {
		return ResourcesPlugin.getWorkspace();
	}

	/**
	 * Returns the string from the plugin's resource bundle,
	 * or 'key' if not found.
	 */
	public static String getResourceString(String key) {
		ResourceBundle bundle= TalkPlugin.getDefault().getResourceBundle();
		try {
			return bundle.getString(key);
		} catch (MissingResourceException e) {
			return key;
		}
	}

	/**
	 * Returns the plugin's resource bundle,
	 */
	public ResourceBundle getResourceBundle() {
		return resourceBundle;
	}
	
	public void startup() throws CoreException{
		super.startup();
		System.err.println("COME");
	}
	
	public void shutdown() throws CoreException{
		super.shutdown();
		System.err.println("SHUT");
	}

	protected void initializeDefaultPreferences(IPreferenceStore store){
		System.err.println("INIT");
		// TODO same as preference class's init
		store.setDefault(TalkPreferencePage.P_SERVER_PORT, "2003");
		store.setDefault(TalkPreferencePage.P_SERVER_AUTO, "false");
	}
}
