/*
 * TextContent.java # 2003-9-28
 * mailto: shenchilang@163.com
 */
package cn.edu.nudt.mice.italk.content;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Text;

import cn.edu.nudt.mice.italk.views.TalkView;
import cn.nudt.edu.mice.italk.peer.TalkPeer;
import cn.nudt.edu.mice.italk.peer.TalkPeerListener;

/**
 * @author Shen Rui
 * <code>TextContent</code>
 */
public class TextContent implements TalkPeerListener {
	public static final String CONTENT_KEY = "content.text";
	
	public TextContent(TalkView view, Composite parent, int style){
		_view = view;
		_text = new Text(parent, style);
		_text.setEditable(false);
		
		makeActions();
	}

	public void setFocus(){
		//_view.setFocus();
	}

	private void makeActions(){
		
	}

	/**
	 * bind new peer to this content
	 * MUST be execute under Display.syncExec()
	 * @safe_thread 
	 */
	public synchronized void _bind(TalkPeer peer){
		if (_peer != null){
			//_peer.removePeerListener(this);	// never remove until close the peer
			_peer.setData(CONTENT_KEY, new StringBuffer(_text.getText()));
		}
		_text.setText("");

		_peer = peer;
		if (_peer != null){
			_peer.addPeerListener(this);	// always add, but only once in fact
			StringBuffer s = (StringBuffer) _peer.getData(CONTENT_KEY);
			if (s == null){
				_text.setText("");
			}else{
				_text.setText(s.toString());
			}
			//_peer.setData(CONTENT_KEY, null);
		}
	}

	public Text getControl(){
		return _text;
	}

	/**
	 * @see cn.nudt.edu.mice.italk.peer.TalkPeerListener#received(cn.nudt.edu.mice.italk.peer.TalkPeer, java.lang.Object)
	 */
	public void received(final TalkPeer peer, final Object data) {
		_text.getDisplay().syncExec(new Runnable(){
			public void run(){
				TextAction action = (TextAction) data;
				if (_peer == peer){	// is current peer
					action.update(TextContent.this);
				}else{	// hidden peer
					StringBuffer s = (StringBuffer) peer.getData(CONTENT_KEY);
					action.update(s);
				}				
			}
		});		
	}

	private TalkView _view;
	private Text _text;
	private TalkPeer _peer;

}
