/*
 * DeleteAction.java # 2003-9-28
 * mailto: shenchilang@163.com
 */
package cn.edu.nudt.mice.italk.content.actions;

import cn.edu.nudt.mice.italk.content.TextAction;
import cn.edu.nudt.mice.italk.content.TextContent;

/**
 * @author Shen Rui
 * <code>DeleteAction</code>
 */
public class DeleteAction implements TextAction {
	public DeleteAction(int start, int end){
		_start = start;
		_end = end;
	}

	public void update(TextContent content) {
		content.getControl().setSelection(_start, _end);
		content.getControl().insert("");
	}

	public void update(StringBuffer content) {
		content.delete(_start, _end);
	}

	public String toString(){
		return "#DEL " + _start + " + " + _end;
	}
	
	private int _start;
	private int _end;

}
