/*
 * InsertAction.java # 2003-9-28
 * mailto: shenchilang@163.com
 */
package cn.edu.nudt.mice.italk.content.actions;

import cn.edu.nudt.mice.italk.content.TextAction;
import cn.edu.nudt.mice.italk.content.TextContent;

/**
 * @author Shen Rui
 * <code>InsertAction</code>, insert a string
 */
public class InsertAction implements TextAction {
	
	public InsertAction(int offset, String s){
		_offset = offset;
		_s = s;
	}

	public void update(TextContent content) {
		content.getControl().setSelection(_offset);
		content.getControl().insert(_s);
	}

	public void update(StringBuffer content) {
		content.insert(_offset, _s);
	}
	
	public String toString(){
		return "#INS " + _offset + " [" + _s + "]";
	}
		
	private int _offset;
	private String _s;
}
