/*
 * ReplaceAction.java # 2003-9-28
 * mailto: shenchilang@163.com
 */
package cn.edu.nudt.mice.italk.content.actions;

import cn.edu.nudt.mice.italk.content.TextAction;
import cn.edu.nudt.mice.italk.content.TextContent;

/**
 * @author Shen Rui
 * <code>ReplaceAction</code>
 */
public class ReplaceAction implements TextAction {

	public ReplaceAction(int start, int end , String s){
		_start = start;
		_end = end;
		_s = s;
	}


	public void update(TextContent content) {
		content.getControl().setSelection(_start, _end);
		content.getControl().insert(_s);
	}

	public void update(StringBuffer content) {
		content.replace(_start, _end, _s);
	}
	public String toString(){
		return "#REP " + _start + " + "+ _end + " [" + _s + "]";
	}
	private int _start;
	private int _end;
	private String _s;
}
